"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantGroupLevelQuestions(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "actionability",
        "clinicalUtility",
        "phenotypesSolved",
        "variantLevelQuestions",
        "variant_group",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "variantLevelQuestions": reports_3_0_0.VariantLevelQuestions,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "actionability": reports_3_0_0.Actionability,
            "clinicalUtility": reports_3_0_0.ClinicalUtility,
            "phenotypesSolved": reports_3_0_0.PhenotypesSolved,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "org.gel.models.report.avro.Actionability": reports_3_0_0.Actionability,
            "org.gel.models.report.avro.ClinicalUtility": reports_3_0_0.ClinicalUtility,
            "org.gel.models.report.avro.PhenotypesSolved": reports_3_0_0.PhenotypesSolved,
            "org.gel.models.report.avro.VariantLevelQuestions": reports_3_0_0.VariantLevelQuestions,
            "org.gel.models.report.avro.VariantGroupLevelQuestions": reports_3_0_0.VariantGroupLevelQuestions,
        }

    __slots__ = [
        "actionability",
        "clinicalUtility",
        "phenotypesSolved",
        "variantLevelQuestions",
        "variant_group",
        "phenotypesExplained",
    ]

    def __init__(
        self,
        actionability,
        clinicalUtility,
        phenotypesSolved,
        variantLevelQuestions,
        variant_group,
        phenotypesExplained=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_3_0_0.VariantGroupLevelQuestions model.

        :param actionability:
            Is evidence for this variant/variant pair sufficient to use it for
            clinical purposes such as prenatal diagnosis or predictive
            testing?
        :type actionability: Actionability
        :param clinicalUtility:
            Has the clinical team identified any changes to clinical care which
            could potentially arise as a result of this
            variant/variant pair?
        :type clinicalUtility: list[ClinicalUtility]
        :param phenotypesSolved:
            Did you report the variant(s) as being partially or completely
            causative of the family's presenting phenotype(s)?
        :type phenotypesSolved: PhenotypesSolved
        :param variantLevelQuestions:
        :type variantLevelQuestions: list[VariantLevelQuestions]
        :param variant_group:
        :type variant_group: int
        :param phenotypesExplained:
            If you indicated that the variant(s) only partially explained the
            family's presenting phenotypes, please indicate which HPO
            terms you are confident that they DO explain
        :type phenotypesExplained: None | list[str]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.0.0"
